; =====
; Dual Charactar Library 1.0.0.4
;   written by hobbyscripter <hobbyscripter@gmail.com>
; =====

; =====
; License
; =====
; This Library is a free software
; Copyright (c) 2006 hobbyscripter

; This software is provided 'as-is', without any express or implied warranty.
; In no event will the authors be held liable for any damages arising from the
; use of this software.

; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute
; it freely, subject to the following restrictions:
;     1. The origin of this software must not be misrepresented;
;        you must not claim that you wrote the original software. If
;        you use this software in a product, an acknowledgment in the
;        product documentation would be appreciated but is not required.
;     2. Altered source versions must be plainly marked as such, and
;        must not be misrepresented as being the original software.
;     3. This notice may not be removed or altered from any source
;        distribution.
; =====

; =====
; What is this?
; =====
; It's a library that can convert dual charactar and special charactar
; into single charactar like %00%00

; =====
; Usage
; =====
; For the Dual Charactar and Special Charactar to Single Charactor
;   [code]
;     ${DualCharToSingleChar} $InputString $OutputString
;   [/code]
; For the Single Charactor to Dual Charactar and Special Charactar
;   [code]
;     ${SingleCharToDualChar} $InputString $OutputString
;   [/code]


; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


!ifndef DualCharLibrary
!define DualCharLibrary

; =====
; Macro (Make this Library much more easy to use)
; =====
!macro DualCharToSingleCharMacro InputString OutputString
  Push ${InputString}
  Call DualCharToSingleCharFunc
  Pop ${OutputString}
!macroend

!macro SingleCharToDualCharMacro InputString OutputString
  Push ${InputString}
  Call SingleCharToDualCharFunc
  Pop ${OutputString}
!macroend

; =====
; Dual Charactar and Special Charactar to Single Charactor
; =====
!macro DualCharToSingleChar
  !ifndef DualCharToSingleChar
    
    !define DualCharToSingleChar "!insertmacro DualCharToSingleCharMacro"
    
    Function DualCharToSingleCharFunc
      ; -----
      ; Functin Init:
      ; -----
      ; Backup the VARIABLE
      Push $R1 ; Stack: [...] << [Input] << $R1
      Exch ; Stack: [...] << $R1 << [Input]
      Pop $R1 ; Stack: [...] << $R1
      Push $R2 ; Stack: [...] << $R1 << $R2
      Push $R3 ; Stack: [...] << $R1 << $R2 << $R3
      Push $R4 ; Stack: [...] << $R1 << $R2 << $R3 << $R4
      Push $R5 ; Stack: [...] << $R1 << $R2 << $R3 << $R4 << $R5
      ; Define the VARIABLE in order to make the code more clear
      !define InputValue $R1
      !define TempFileName $R2
      !define FileHandler $R3
      !define CurrentCharCode $R4
      !define OutputValue $R5
      ; Clear the OutputValue
      StrCpy ${OutputValue} ""
      
      ; -----
      ; Write the InputValue into a file:
      ; -----
      InitPluginsDir
      GetTempFileName ${TempFileName} $PLUGINSDIR
      FileOpen ${FileHandler} ${TempFileName} w
      FileWrite ${FileHandler} ${InputValue}
      FileClose ${FileHandler}
      
      ; -----
      ; Read the file in binary mode:
      ; -----
      ClearErrors
      FileOpen ${FileHandler} ${TempFileName} r
      ReadingWhile:
        FileReadByte ${FileHandler} ${CurrentCharCode}
        IfErrors ReadingWend 0
        ; Processing:
        IntCmp ${CurrentCharCode} 128 IsDualChar 0 IsDualChar
        ; Special Charactar List:
        IntCmp ${CurrentCharCode} 32 IsSpecialChar 0 0 ; " " (32) => %20
        IntCmp ${CurrentCharCode} 35 IsSpecialChar 0 0 ; "#" (35) => %23
        IntCmp ${CurrentCharCode} 37 IsSpecialChar 0 0 ; "%" (37) => %25
        IntCmp ${CurrentCharCode} 59 IsSpecialChar 0 0 ; ";" (59) => %3B
        IntCmp ${CurrentCharCode} 91 IsSpecialChar 0 0 ; "[" (91) => %5B
        IntCmp ${CurrentCharCode} 93 IsSpecialChar 0 0 ; "]" (93) => %5D
        IntCmp ${CurrentCharCode} 94 IsSpecialChar 0 0 ; "^" (94) => %5E
        IntCmp ${CurrentCharCode} 96 IsSpecialChar 0 0 ; "`" (96) => %60
      ;IsSingleChar:
          FileSeek ${FileHandler} -1 CUR
          FileRead ${FileHandler} ${CurrentCharCode} 1
          StrCpy ${OutputValue} "${OutputValue}${CurrentCharCode}"
          Goto ReadingWhile
        IsDualChar:
          IntFmt ${CurrentCharCode} "%X" ${CurrentCharCode}
          StrCpy ${OutputValue} "${OutputValue}%${CurrentCharCode}"
          FileReadByte ${FileHandler} ${CurrentCharCode}
          IfErrors ReadingWend 0 ; Check if is the last word, this may happen in ascii char in which code is bigger than 128
          IntFmt ${CurrentCharCode} "%X" ${CurrentCharCode}
          StrCpy ${OutputValue} "${OutputValue}%${CurrentCharCode}"
          Goto ReadingWhile
        IsSpecialChar:
          IntFmt ${CurrentCharCode} "%X" ${CurrentCharCode}
          StrCpy ${OutputValue} "${OutputValue}%${CurrentCharCode}"
          Goto ReadingWhile
      ReadingWend:
      ClearErrors
      FileClose ${FileHandler}
      
      ; -----
      ; Finishing the function:
      ; -----
      ; Delete the temp file
      Delete ${TempFileName}
      ; Undefine the VARIABLE
      !undef InputValue $R1
      !undef TempFileName $R2
      !undef FileHandler $R3
      !undef CurrentCharCode $R4
      !undef OutputValue $R5
      ; Output the OutputValue
      StrCpy $R1 $R5 ; Copy the OutputValue to $R1
      Pop $R5 ; Stack: [...] << $R1 << $R2 << $R3 << $R4
      Pop $R4 ; Stack: [...] << $R1 << $R2 << $R3
      Pop $R3 ; Stack: [...] << $R1 << $R2
      Pop $R2 ; Stack: [...] << $R1
      Push $R1 ; Stack: [...] << $R1 << [Output]
      Exch
      Pop $R1
    FunctionEnd
  !endif
!macroend

; =====
; Single Charactor to Dual Charactar and Special Charactar
; =====
!macro SingleCharToDualChar
  !ifndef SingleCharToDualChar
    !define SingleCharToDualChar "!insertmacro SingleCharToDualCharMacro"
    
    Function SingleCharToDualCharFunc
      ; -----
      ; Functin Init:
      ; -----
      ; Backup the VARIABLE
      Push $R1 ; Stack: [...] << [Input] << $R1
      Exch ; Stack: [...] << $R1 << [Input]
      Pop $R1 ; Stack: [...] << $R1
      Push $R2 ; Stack: [...] << $R1 << $R2
      Push $R3 ; Stack: [...] << $R1 << $R2 << $R3
      Push $R4 ; Stack: [...] << $R1 << $R2 << $R3 << $R4
      Push $R5 ; Stack: [...] << $R1 << $R2 << $R3 << $R4 << $R5
      ; Define the VARIABLE in order to make the code more clear
      !define InputValue $R1
      !define InputStringLength $R2
      !define InputStringPosition $R3
      !define CurrentCharCode $R4
      !define OutputValue $R5
      ; Clear the OutputValue
      StrCpy ${OutputValue} ""
      ; Initial ${InputStringPosition}
      IntOp ${InputStringPosition} 0 + 0 ; ${InputStringPosition} = 0
      
      ; -----
      ; Processing:
      ; -----
      StrLen ${InputStringLength} ${InputValue}
      ConvertingWhile:
        IntCmp ${InputStringPosition} ${InputStringLength} ConvertingWend 0 ConvertingWend ; Only when ${InputStringPosition} < ${InputStringLength} will go next, because ${InputStringLength} is start from 0.
        StrCpy ${CurrentCharCode} ${InputValue} 1 ${InputStringPosition}
        IntOp ${InputStringPosition} ${InputStringPosition} + 1 ; Let ${InputStringPosition} go forward
        StrCmp ${CurrentCharCode} "%" IsEscape IsChar
        IsEscape:
          StrCpy ${CurrentCharCode} ${InputValue} 2 ${InputStringPosition}
          IntOp ${InputStringPosition} ${InputStringPosition} + 2 ; Let ${InputStringPosition} go forward
          IntFmt ${CurrentCharCode} "%c" "0x${CurrentCharCode}"
          StrCpy ${OutputValue} "${OutputValue}${CurrentCharCode}"
          Goto ConvertingWhile
        IsChar:
          StrCpy ${OutputValue} "${OutputValue}${CurrentCharCode}"
          Goto ConvertingWhile
      ConvertingWend:

      ; -----
      ; Finishing the function:
      ; -----
      ; Undefine the VARIABLE
      !undef InputValue
      !undef InputStringLength
      !undef InputStringPosition
      !undef CurrentCharCode
      !undef OutputValue
      ; Output the OutputValue
      StrCpy $R1 $R5 ; Copy the OutputValue to $R1
      Pop $R5 ; Stack: [...] << $R1 << $R2 << $R3 << $R4
      Pop $R4 ; Stack: [...] << $R1 << $R2 << $R3
      Pop $R3 ; Stack: [...] << $R1 << $R2
      Pop $R2 ; Stack: [...] << $R1
      Push $R1 ; Stack: [...] << $R1 << [Output]
      Exch
      Pop $R1
    FunctionEnd
  !endif
!macroend

!endif
