;Copyright (C) 2004-2006 John T. Haller
;Portions Copyright 2004 mai9
;Patched and modified by hobbyscripter

;Website: http://PortableApps.com/PortableFirefox

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

!define FULLNAME "Mozilla Firefox - Portable CE Edition" ; edited by hobbyscripter
!define NAME "FirefoxPortableCE" ; edited by hobbyscripter
!define APP "Firefox"
!define VER "1.2.1.1"
!define WEBSITE "PortableApps.com/FirefoxPortable"
!define DEFAULTEXE "firefox.exe"
!define DEFAULTAPPDIR "firefox"
!define DEFAULTUSERPROFILEDIR "userprofile"
;!define UseEscapedGetParametersFunc ; added by hobbyscripter, to fix Chinese BIG5 Problems

;=== add plugin search dir
; added by hobbyscripter, in order to make it much easy to recompile
!addplugindir NSISplugins

;=== i18n area (added by hobbyscripter)
; include all the language file here
!include "lang\english.nsh"
!include "lang\tradchinese.nsh"

;=== include the Dual Char Library (added by hobbyscripter)
; for the dual charactar support
!include "DualChar.lib.nsh"
!insertmacro DualCharToSingleChar
!ifdef UseEscapedGetParametersFunc ; for GetParameters
  !insertmacro SingleCharToDualChar
!endif

;=== Program Details
Name "${NAME}"
OutFile "..\..\${NAME}.exe" ; edited by hobbyscripter
Caption "${FULLNAME} | PortableApps.com"
VIProductVersion "${VER}"
VIAddVersionKey FileDescription "${FULLNAME}"
VIAddVersionKey LegalCopyright "2004-2006 John T. Haller, portions 2004 by mai9" ; edited by hobbyscripter, sorry because in my computer Gerard Balague' (mai9) can't be show correctly
VIAddVersionKey Comments "Allows ${APP} to be run from a removable drive.  For additional details, visit ${WEBSITE}"
VIAddVersionKey CompanyName "PortableApps.com and hobbyscripter"
VIAddVersionKey OriginalFilename "${NAME}.exe"
VIAddVersionKey FileVersion "${VER}"

;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True
SetCompressor lzma ; added by hobbyscripter, in order to have better compressor ratio and smaller executable size.

;=== Program Icon
Icon "graphic\${NAME}.ico" ; edited by hobbyscripter

Var PROGRAMDIRECTORY
Var PROFILEDIRECTORY
Var PROFILEDIRFORCHROME ;added by hobbyscripter, for the Chinese BIG5 Characters support
Var PLUGINSDIRECTORY
Var USERPROFILEDIRECTORY
Var ADDITIONALPARAMETERS
Var ALLOWMULTIPLEINSTANCES
Var SKIPCHROMEFIX
Var SKIPCOMPREGFIX
Var EXECSTRING
Var WAITFORPROGRAM
Var PROGRAMEXECUTABLE
Var INIPATH
Var ISFILELINE
Var DISABLESPLASHSCREEN
Var LOCALHOMEPAGE
Var ISDEFAULTDIRECTORY
Var RUNLOCALLY
;Var TEMPPATH ; deleted by hobbyscripter, using $PluginsDir\${NAME} instead of $TEMPPATH, Note: You may use $TEMP instead of $TEMPPATH
Var SKIPUSEFIREFOXFORMATPATH ; added by hobbyscripter, for the Chinese BIG5 Characters support
Var DYNAMICSPLASH ; added by hobbyscripter, for the Dynamic Splash support


Section "Main"
	;=== Find the INI file, if there is one
		IfFileExists "$EXEDIR\${NAME}.ini" "" CheckSubINI
			StrCpy "$INIPATH" "$EXEDIR"
			Goto ReadINI

	CheckSubINI:
		IfFileExists "$EXEDIR\${NAME}\${NAME}.ini" "" CheckSubSubINI
			StrCpy "$INIPATH" "$EXEDIR\${NAME}"
			Goto ReadINI

	CheckSubSubINI:
		IfFileExists "$EXEDIR\PortableApps\${NAME}\${NAME}.ini" "" CheckPortableAppsINI
			StrCpy "$INIPATH" "$EXEDIR\PortableApps\${NAME}"
			Goto ReadINI

	CheckPortableAppsINI:
		IfFileExists "$EXEDIR\Data\${NAME}\${NAME}.ini" ""  NoINI
			StrCpy "$INIPATH" "$EXEDIR\Data\${NAME}"
			Goto ReadINI

	ReadINI:
		;=== Read the parameters from the INI file
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Directory"
		StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "ProfileDirectory"
		StrCpy "$PROFILEDIRECTORY" "$EXEDIR\$0"

		;=== Check that the above required parameters are present
		IfErrors NoINI

		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "PluginsDirectory"
		StrCpy "$PLUGINSDIRECTORY" "$EXEDIR\$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "UserProfileDirectory"
		StrCmp $0 "" NoUserProfile
			StrCpy "$USERPROFILEDIRECTORY" "$EXEDIR\$0"
		NoUserProfile:
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AdditionalParameters"
		StrCpy "$ADDITIONALPARAMETERS" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AllowMultipleInstances"
		StrCpy "$ALLOWMULTIPLEINSTANCES" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipChromeFix"
		StrCpy "$SKIPCHROMEFIX" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipCompregFix"
		StrCpy "$SKIPCOMPREGFIX" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "WaitFor${APP}"
		StrCpy "$WAITFORPROGRAM" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Executable"
		StrCpy "$PROGRAMEXECUTABLE" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "DisableSplashScreen"
		StrCpy "$DISABLESPLASHSCREEN" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "LocalHomepage"
		StrCpy "$LOCALHOMEPAGE" $0
 		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SkipUseFirefoxFormatPath" ; added by hobbyscripter, for the Chinese BIG5 Characters support
		StrCpy "$SKIPUSEFIREFOXFORMATPATH" $0
  		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "DynamicSplash" ; for the DynamicSplash
		StrCpy "$DYNAMICSPLASH" "$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "RunLocally"
		StrCpy "$RUNLOCALLY" $0
		StrCmp "$RUNLOCALLY" "true" "" CleanUpAnyErrors
		StrCpy "$WAITFORPROGRAM" "$RUNLOCALLY"
		
	CleanUpAnyErrors:
		;=== Any missing unrequired INI entries will be an empty string, ignore associated errors
		ClearErrors

		;=== Correct PROGRAMEXECUTABLE if blank
		StrCmp $PROGRAMEXECUTABLE "" "" EndINI
			StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
			Goto EndINI

	NoINI:
		;=== No INI file, so we'll use the defaults
		StrCpy "$ADDITIONALPARAMETERS" ""
		StrCpy "$ALLOWMULTIPLEINSTANCES" "false"
		StrCpy "$SKIPCHROMEFIX" "false"
		StrCpy "$SKIPCOMPREGFIX" "false"
		StrCpy "$WAITFORPROGRAM" "false"
		StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
		StrCpy "$DISABLESPLASHSCREEN" "false"
		StrCpy "$SKIPUSEFIREFOXFORMATPATH" "false" ; added by hobbyscripter for Firefox Format Support
 		StrCpy "$DYNAMICSPLASH" "" ; added by hobbyscripter for the Dynamic Support

		IfFileExists "$EXEDIR\App\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableProgramDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\App\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\Data\profile"
			StrCpy "$PLUGINSDIRECTORY" "$EXEDIR\Data\plugins"
			StrCpy "$USERPROFILEDIRECTORY" "$EXEDIR\Data\userprofile"
			StrCpy "$ISDEFAULTDIRECTORY" "true"
			GoTo EndINI

		CheckPortableProgramDIR:
			IfFileExists "$EXEDIR\${NAME}\App\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\${NAME}\App\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\${NAME}\Data\profile"
			StrCpy "$PLUGINSDIRECTORY" "$EXEDIR\${NAME}\Data\plugins"
			StrCpy "$USERPROFILEDIRECTORY" "$EXEDIR\${NAME}\Data\userprofile"
			GoTo EndINI

		CheckPortableAppsDIR:
			IfFileExists "$EXEDIR\PortableApps\${NAME}\App\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsSplitDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\PortableApps\${NAME}\App\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\PortableApps\${NAME}\Data\profile"
			StrCpy "$PLUGINSDIRECTORY" "$EXEDIR\PortableApps\${NAME}\Data\plugins"
			StrCpy "$USERPROFILEDIRECTORY" "$EXEDIR\PortableApps\${NAME}\Data\userprofile"
			GoTo EndINI

		CheckPortableAppsSplitDIR:
			IfFileExists "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" NoProgramEXE
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}"
			StrCpy "$PROFILEDIRECTORY" "$EXEDIR\Data\${NAME}\profile"
			StrCpy "$PLUGINSDIRECTORY" "$EXEDIR\Data\${NAME}\plugins"
			IfFileExists "$EXEDIR\Data\UserProfile\*.*" "" UniqueUserProfileDIR
				;=== Shared UserProfile directory
				StrCpy "$USERPROFILEDIRECTORY" "$EXEDIR\Data\UserProfile"
				GoTo EndINI

			UniqueUserProfileDIR:
				StrCpy "$USERPROFILEDIRECTORY" "$EXEDIR\Data\${NAME}\userprofile"
			GoTo EndINI	

	EndINI:
		IfFileExists "$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" FoundProgramEXE

	NoProgramEXE:
		;=== Program executable not where expected
		MessageBox MB_OK|MB_ICONEXCLAMATION `$(NoExecutableFound)` ; edited by hobbyscripter, for the i18n support
		Abort
		
	FoundProgramEXE:
	;=== Check if Firefox is running
	StrCmp $ALLOWMULTIPLEINSTANCES "true" ProfileWork
	FindProcDLL::FindProc "firefox.exe"
		Pop $R0
		StrCmp $R0 "1" "" ProfileWork
		;=== Firefox is already running, check if it is using the portable profile
		IfFileExists "$PROFILEDIRECTORY\parent.lock" ProfileWork
		
		MessageBox MB_OK|MB_ICONINFORMATION `$(FirefoxAlreadyRunning)` ; edited by hobbyscripter, for the i18n support
		Abort
	
	ProfileWork:
	;=== Check for an existing profile
	IfFileExists "$PROFILEDIRECTORY\prefs.js" ProfileFound
		;=== No profile was found
		StrCmp $ISDEFAULTDIRECTORY "true" CopyDefaultProfile
		MessageBox MB_YESNO|MB_ICONQUESTION `$(CreateProfileQuestion)` IDYES CreateProfile ; edited by hobbyscripter, for the i18n support
		MessageBox MB_OK|MB_ICONINFORMATION `$(NoProfileError)` ; edited by hobbyscripter, for the i18n support
		Abort
	
	CopyDefaultProfile:
		CreateDirectory "$EXEDIR\Data"
		CreateDirectory "$EXEDIR\Data\plugins"
		CreateDirectory "$EXEDIR\Data\profile"
		CopyFiles /SILENT "$EXEDIR\App\DefaultData\plugins\*.*" "$EXEDIR\Data\plugins"
		CopyFiles /SILENT "$EXEDIR\App\DefaultData\profile\*.*" "$EXEDIR\Data\profile"
		GoTo ProfileFound
	
	CreateProfile:
		IfFileExists "$PROFILEDIRECTORY\*.*" ProfileFound
		CreateDirectory "$PROFILEDIRECTORY"

	ProfileFound:
		;=== Check for read/write
		StrCmp $RUNLOCALLY "true" DisplaySplash
		ClearErrors
		FileOpen $R0 "$PROFILEDIRECTORY\writetest.temp" w
		IfErrors "" WriteSuccessful
			;== Write failed, so we're read-only
			MessageBox MB_YESNO|MB_ICONQUESTION `$(RunLocallyQuestion)` IDYES SwitchToRunLocally ; edited by hobbyscripter, for the i18n support
			MessageBox MB_OK|MB_ICONINFORMATION `$(ReadOnlyError)` ; edited by hobbyscripter, for the i18n support
			Abort
			
	SwitchToRunLocally:
		StrCpy $RUNLOCALLY "true"
		StrCpy $WAITFORPROGRAM "true"
		Goto DisplaySplash
	
	WriteSuccessful:
		FileClose $R0
		Delete "$PROFILEDIRECTORY\writetest.temp"
		
	
	DisplaySplash:
		StrCmp $DISABLESPLASHSCREEN "true" SkipSplashScreen
			;=== Show the splash screen before processing the files
			; Edit by Hobbyscripter
			; To Add Dynamic Change Splash Support
			ClearErrors
			Var /GLOBAL "SPLASHIMAGENAME"
			StrCmp $DYNAMICSPLASH "" 0 PreparedSplashImage
				DefaultSplash:
				InitPluginsDir
				File /oname=$PLUGINSDIR\splash.bmp "graphic\${NAME}.bmp" ; edited by hobbyscripter, to fix Win98 SE Runtime Error
				StrCpy $SPLASHIMAGENAME "$PLUGINSDIR\splash.bmp" ; edited by hobbyscripter, to fix Win98 SE Runtime Error
				Goto CallSplashPlugin
			PreparedSplashImage:
			StrCpy $SPLASHIMAGENAME $DYNAMICSPLASH
			GetFullPathName $SPLASHIMAGENAME "$EXEDIR\$SPLASHIMAGENAME"
			IfErrors 0 CallSplashPlugin
			        ClearErrors
			        Goto DefaultSplash

                        CallSplashPlugin:
			StrCmp $WAITFORPROGRAM "true" ShortSplashScreen
			newadvsplash::show /NOUNLOAD 30000 400 0 -1 /L $SPLASHIMAGENAME
			GoTo SkipSplashScreen
			
			ShortSplashScreen:
				newadvsplash::show /NOUNLOAD 3000 200 0 -1 /L $SPLASHIMAGENAME

	SkipSplashScreen:
		;=== Run locally if needed (aka Portable Firefox Live)
		StrCmp $RUNLOCALLY "true" "" AdjustChrome
		InitPluginsDir
		CreateDirectory "$PLUGINSDIR\${NAME}\profile"
		CreateDirectory "$PLUGINSDIR\${NAME}\plugins"
		CreateDirectory "$PLUGINSDIR\${NAME}\program"
		
		CopyFiles /SILENT "$PROFILEDIRECTORY\*.*" "$PLUGINSDIR\${NAME}\profile"
		StrCpy $PROFILEDIRECTORY "$PLUGINSDIR\${NAME}\profile"
		Push $PROFILEDIRECTORY
		Call Attrib
		
		CopyFiles /SILENT "$PLUGINSDIRECTORY\*.*" "$PLUGINSDIR\${NAME}\plugins"
		StrCpy $PLUGINSDIRECTORY "$PLUGINSDIR\${NAME}\plugins"
		Push $PLUGINSDIRECTORY
		Call Attrib
		
		CopyFiles /SILENT "$PROGRAMDIRECTORY\*.*" "$PLUGINSDIR\${NAME}\program"
		StrCpy $PROGRAMDIRECTORY "$PLUGINSDIR\${NAME}\program"
		Push $PROGRAMDIRECTORY
		Call Attrib
		
		IfFileExists "$PROFILEDIRECTORY\chrome\chrome.rdf" "" FixCalendarManager

	AdjustChrome:
		;=== Chinese BIG5 Characters convert area (added by hobbyscripter)
		StrCmp $SKIPUSEFIREFOXFORMATPATH "true" UseOrginalPath 0
			${DualCharToSingleChar} $PROFILEDIRECTORY $PROFILEDIRFORCHROME
			Goto EndOfConvert
		UseOrginalPath:
			StrCpy $PROFILEDIRFORCHROME $PROFILEDIRECTORY
		EndOfConvert:

		IfFileExists "$PROFILEDIRECTORY\chrome\chrome.rdf" "" FixCalendarManager

		;=== Adjust the chrome.rdf
		StrCmp $SKIPCHROMEFIX "true" FixPrefsJs ; edited by hobbyscripter, to make sure prefs.js will be fixed
		FileOpen $0 "$PROFILEDIRECTORY\chrome\chrome.rdf" r
		FileOpen $R0 "$PROFILEDIRECTORY\chrome\chrome.rdf.new" w
		ClearErrors ; if there's an error, we're done with the file
	
		NextLine:
			FileWrite $R0 $4
			FileRead $0 $4
			IfErrors NoMoreLines ;== we've reached the end of the file
			StrCpy $5 $4 35
			StrCmp $5 `                   c:baseURL="jar:f` FoundJarLine
			StrCmp $5 `                   c:baseURL="file:` FoundFileLine NextLine

		FoundJarLine:
			StrCpy $R4 40
			StrCpy $ISFILELINE "0"
			GoTo NotYet

		FoundFileLine:
			StrCpy $R4 40
			StrCpy $ISFILELINE "1"

		NotYet:
			IntOp $R4 $R4 + 1
			StrCpy $7 $4 10 $R4 ;=== looking for the point to strip the extension path
			StrCmp $7 "extensions" PathFound NotYet
	
		PathFound:
			StrCpy $5 $4 "" $R4
			StrCmp $ISFILELINE "0" MakeJarLine MakeFileLine

		MakeJarLine:
			StrCpy $4 `                   c:baseURL="jar:file:///$PROFILEDIRFORCHROME/$5` ; edited by hobbyscripter, for the Chinese BIG5 Characters support
			GoTo NextLine

		MakeFileLine:
			StrCpy $4 `                   c:baseURL="file:///$PROFILEDIRFORCHROME/$5` ; edited by hobbyscripter, for the Chinese BIG5 Characters support
			GoTo NextLine

		NoMoreLines:
			FileClose $0
			FileClose $R0

			;=== Backup the chrome.rdf
			CopyFiles /SILENT "$PROFILEDIRECTORY\chrome\chrome.rdf" "$PROFILEDIRECTORY\chrome\chrome.rdf.old"
			CopyFiles /SILENT "$PROFILEDIRECTORY\chrome\chrome.rdf.new" "$PROFILEDIRECTORY\chrome\chrome.rdf" 

	FixCalendarManager:
		IfFileExists "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" "" FixPrefsJs

		FileOpen $0 "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" r
		FileOpen $R0 "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf.new" w
		ClearErrors ; if there's an error, we're done with the file
	
		CMNextLine:
			FileWrite $R0 $4
			FileRead $0 $4
			IfErrors CMNoMoreLines ;== we've reached the end of the file
			StrCpy $5 $4 28
			StrCmp $5 `                   NC:path="` "" CMNextLine
			StrCpy $R4 28
	
		CMNotYet:
			IntOp $R4 $R4 + 1
			StrCpy $7 $4 9 $R4 ; looking for the point to strip the calendar path
			StrCmp $7 "Calendar\" "" CMNotYet
			StrCpy $5 $4 "" $R4
			StrCpy $4 `                   NC:path="$PROFILEDIRFORCHROME\$5` ;=== the adjusted extension path ; edited by hobbyscripter, for the Chinese BIG5 Characters support
			GoTo CMNextLine

		CMNoMoreLines:
			FileClose $0
			FileClose $R0

			;=== Backup the Calendar\CalendarManager.rdf just in case
			CopyFiles /SILENT "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf.old"
			CopyFiles /SILENT "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf.new" "$PROFILEDIRECTORY\Calendar\CalendarManager.rdf" 
	
	FixPrefsJs:
		;IfFileExists "$PROFILEDIRECTORY\prefs.js" "" 0 ; deleted by hobbyscripter, to fix Prefs.js anyway (While the first time Firefox Portable be used, it shouldn't ask to be set to default browser.
		;=== Be sure the xul cache is enabled and default browser check is disabled
		FileOpen $0 "$PROFILEDIRECTORY\prefs.js" a
		FileSeek $0 0 END
		FileWriteByte $0 "13"
		FileWriteByte $0 "10"
		FileWrite $0 `user_pref("browser.shell.checkDefaultBrowser", false);`
		FileWriteByte $0 "13"
		FileWriteByte $0 "10"
		StrCmp "$LOCALHOMEPAGE" "" FixPrefsJsClose
		FileWrite $0 `user_pref("browser.startup.homepage", "file:///$EXEDIR/$LOCALHOMEPAGE");`
		FileWriteByte $0 "13"
		FileWriteByte $0 "10"
		
	FixPrefsJsClose:
		FileClose $0
	
	;RunProgram:
		StrCmp $SKIPCOMPREGFIX "true" GetPassedParameters

		;=== Delete component registry to ensure compatibility with all extensions
		Delete $PROFILEDIRECTORY\compreg.dat

	GetPassedParameters:
		;=== Get any passed parameters
		Call GetParameters
		Pop $0
		StrCmp "'$0'" "''" "" LaunchProgramParameters

		;=== No parameters
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" -profile "$PROFILEDIRECTORY"`
		Goto CheckMultipleInstances

	LaunchProgramParameters:
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" -profile "$PROFILEDIRECTORY" $0`

	CheckMultipleInstances:
		StrCmp $ALLOWMULTIPLEINSTANCES "true" "" AdditionalParameters
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("MOZ_NO_REMOTE", "1").r0'

	AdditionalParameters:
		StrCmp $ADDITIONALPARAMETERS "" PluginsEnvironment

		;=== Additional Parameters
		StrCpy $EXECSTRING `$EXECSTRING $ADDITIONALPARAMETERS`

	PluginsEnvironment:
		;=== Set the plugins directory if we have a path
		StrCmp $PLUGINSDIRECTORY "" UserProfileEnvironment
		IfFileExists "$PLUGINSDIRECTORY\*.*" "" UserProfileEnvironment
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("MOZ_PLUGIN_PATH", "$PLUGINSDIRECTORY").r0'

	UserProfileEnvironment:
		;=== Set the %USERPROFILE% directory if we have a path
		StrCmp $USERPROFILEDIRECTORY "" LaunchNow
		IfFileExists "$USERPROFILEDIRECTORY\*.*" "" LaunchNow
		System::Call 'Kernel32::SetEnvironmentVariableA(t, t) i("USERPROFILE", "$USERPROFILEDIRECTORY").r0'

	LaunchNow:
		StrCmp $WAITFORPROGRAM "true" LaunchAndWait LaunchAndClose

	LaunchAndWait:
		ExecWait $EXECSTRING
	CheckRunning:
		Sleep 2000
		StrCmp $ALLOWMULTIPLEINSTANCES "true" TheEnd
		FindProcDLL::FindProc "$PROGRAMEXECUTABLE" ; edited by hobbyscripter
		Pop $R0                     
		StrCmp $R0 "1" CheckRunning CleanupRunLocally

	LaunchAndClose:
		Exec $EXECSTRING
		Sleep 3000 ;=== allow the splash screen to show for at least 2 seconds after starting Firefox
		StrCmp $DISABLESPLASHSCREEN "true" TheEnd
			newadvsplash::stop
		Goto TheEnd
		
	CleanupRunLocally:
		StrCmp $RUNLOCALLY "true" "" TheEnd
		RMDir /r "$PLUGINSDIR\${NAME}\" ; edited by hobbyscripter

	TheEnd:
		newadvsplash::stop

SectionEnd

!ifdef UseEscapedGetParametersFunc
  !echo "Precompile Trunk: UseEscapedGetParametersFunc (Ln:${__LINE__})"

  ;=== Get Paraemeters Function ; rewritten by hobbyscripter
  Function "GetParameters"
    ; -----
    ; Function Init
    ; -----
    ; Backup the VARIABLE
    Push $R0 ; Stack: [...] << $R0
    Push $R1 ; Stack: [...] << $R0 << $R1
    Push $R2 ; Stack: [...] << $R0 << $R1 << $R2
    Push $R3 ; Stack: [...] << $R0 << $R1 << $R2 << $R3
    Push $R4 ; Stack: [...] << $R0 << $R1 << $R2 << $R3 << $R4
    Push $R5 ; Stack: [...] << $R0 << $R1 << $R2 << $R3 << $R4 << $R5
    ; Give the VARIABLE a clear name
    !define CopyOfCommandLine $R0
    !define StringLength $R1
    !define SearchTarget $R2
    !define CurrentChar $R3
    !define Position $R4
    !define Output $R5
    ; Clear The Errors
    ClearErrors

    ; -----
    ; Check the Command Line Format
    ; -----
    StrCpy ${CurrentChar} $CMDLINE 1
    ; If_FirstCharEqualQuote:
    StrCmp ${CurrentChar} '"' 0 UsingSpace ; Check if using format like `"executable" parameters` or `executable parameters`
      StrCpy ${SearchTarget} '"' ; Make SearchTarget
      StrCmp $SKIPUSEFIREFOXFORMATPATH "true" SkipEscape 0
        ${DualCharToSingleChar} $CMDLINE ${CopyOfCommandLine} ; Make a copy for CMDLINE
        Goto EndIf_FirstCharEqualQuote
      SkipEscape:
        StrCpy ${CopyOfCommandLine} $CMDLINE ; Make a copy for CMDLINE
        Goto EndIf_FirstCharEqualQuote
    UsingSpace:
      StrCpy ${SearchTarget} ' ' ; Make SearchTarget
      StrCpy ${CopyOfCommandLine} $CMDLINE ; Make a copy for CMDLINE
    EndIf_FirstCharEqualQuote:

    ; -----
    ; Get The Length Of $CMDLINE
    ; -----
    StrLen ${StringLength} ${CopyOfCommandLine}

    ; -----
    ; Search The Target
    ; -----
    StrCpy ${Position} 1 ; Start from 0 but '"' is a character as well, so +1
    While_FoundSearchTarget:
      ; If_PositionLessLengthOfCommandLine:
      IntCmp ${Position} ${StringLength} Wend_FoundSearchTarget 0 Wend_FoundSearchTarget
      StrCpy ${CurrentChar} ${CopyOfCommandLine} 1 ${Position}
      StrCmp ${CurrentChar} ${SearchTarget} Wend_FoundSearchTarget
      IntOp ${Position} ${Position} + 1
      Goto While_FoundSearchTarget
      ; Else_PositionLessLengthOfCommandLine:
        ; Goto Wend_FoundSearchTarget
      ; EndIf_PositionLessLengthOfCommandLine:
    Wend_FoundSearchTarget:
    IntOp ${Position} ${Position} + 1 ; Point to the next char of SearchTarget

    ; -----
    ; Copy Output Words
    ; -----
    StrCpy ${Output} ${CopyOfCommandLine} "" ${Position}

    ; -----
    ; Unescape the result
    ; -----
    ; If_SearchTargetEqualQuote
    StrCmp ${SearchTarget} '"' 0 EndIf_SearchTargetEqualQuote
      ; If_SkipUseFirefoxFormatPathEqualFalse:
      StrCmp $SkipUseFirefoxFormatPath "false" 0 EndIf_SearchTargetEqualQuote
        ${SingleCharToDualChar} ${Output} ${Output}
      ; EndIf_SkipUseFirefoxFormatPathEqualFalse
    EndIf_SearchTargetEqualQuote:

    ; -----
    ; Clear The Space
    ; -----
    ; Front Space
    IntOp ${Position} 0 + 0 ; New Position
    StrLen ${StringLength} ${Output} ; New Length for Output
    While_NoMoreFrontSpace:
      ; If_PositionLessLengthOfOutput:
      IntCmp ${Position} ${StringLength} Wend_NoMoreFrontSpace 0 Wend_NoMoreFrontSpace
        StrCpy ${CurrentChar} ${Output} 1 ${Position}
        ; If_CurrentCharEqualSpace:
        StrCmp ${CurrentChar} ' ' 0 Wend_NoMoreFrontSpace
          IntOp ${Position} ${Position} + 1
          Goto While_NoMoreFrontSpace
        ; EndIf_CurrentCharEqualSpace:
      ; EndIf_PositionLessLengthOfOutput:
    Wend_NoMoreFrontSpace:
    StrCpy ${Output} ${Output} "" ${Position} ; Cut the String to delete the space
    ; End Space
    StrLen ${StringLength} ${Output} ; New Position
    IntOp ${Position} ${StringLength} - 1 ; New Length for Output
    While_NoMoreEndSpace:
      ; If_PositionLessLengthOfOutput:
      IntCmp ${Position} 0 0 Wend_NoMoreEndSpace 0
        StrCpy ${CurrentChar} ${Output} 1 ${Position}
        ; If_CurrentCharEqualSpace:
        StrCmp ${CurrentChar} ' ' 0 Wend_NoMoreEndSpace
          IntOp ${Position} ${Position} - 1
          Goto While_NoMoreEndSpace
        ; EndIf_CurrentCharEqualSpace:
      ; EndIf_PositionLessLengthOfOutput:
    Wend_NoMoreEndSpace:
    IntOp ${Position} ${Position} + 1 ; Because MaxLength Of StrCpy is start with 1
    StrCpy ${Output} ${Output} ${Position} ; Cut the String to delete the space

    ; -----
    ; Function Ending
    ; -----
    ; Undefine the Name
    !undef CopyOfCommandLine
    !undef StringLength
    !undef SearchTarget
    !undef CurrentChar
    !undef Position
    !undef Output
    ; Recover the VARIABLES and return the value
    StrCpy $R0 $R5 ; Exchange
    Pop $R5 ; Stack: [...] << $R0 << $R1 << $R2 << $R3 << $R4
    Pop $R4 ; Stack: [...] << $R0 << $R1 << $R2 << $R3
    Pop $R3 ; Stack: [...] << $R0 << $R1 << $R2
    Pop $R2 ; Stack: [...] << $R0 << $R1
    Pop $R1 ; Stack: [...] << $R0
    Exch $R0 ; Stack: [...] << [Output]
  FunctionEnd
!else
  !echo "Precompile Trunk: UseOriginalGetParametersFunc (Ln:${__LINE__})"

  ;=== Get Paraemeters Function
  Function GetParameters
    Push $R0
    Push $R1
    Push $R2
    Push $R3

    StrCpy $R2 1
    StrLen $R3 $CMDLINE

    ;Check for quote or space
    StrCpy $R0 $CMDLINE $R2
    StrCmp $R0 '"' 0 +3
      StrCpy $R1 '"'
      Goto loop
    StrCpy $R1 " "

    loop:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 get
      StrCmp $R2 $R3 get
      Goto loop

    get:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " get
      StrCpy $R0 $CMDLINE "" $R2

    Pop $R3
    Pop $R2
    Pop $R1
    Exch $R0
  FunctionEnd
!endif

;=== Clear Read-Only Function
Function Attrib
  Exch $1 ; Dir
  Push $2
  Push $3
  FindFirst $2 $3 "$1\*.*"
  StrCmp $3 "" exitloop
  loop:
  StrCmp $3 "" exitloop
  StrCmp $3 "." next
  StrCmp $3 ".." next
  IfFileExists "$1\$3\*.*" next
  ; SetFileAttributes does not accept variables as attribute,
  ; so manually set this to the necessary value.
  SetFileAttributes "$1\$3" NORMAL
  next:
  FindNext $2 $3
  Goto loop
  exitloop:
  FindClose $2
  Pop $3
  Pop $2
  Pop $1
FunctionEnd